#include <stdio.h>
#include <math.h>
#include "winbgi2.h"
#define N 200
void iterj(double a[][N],double b[],int n,double eps,double x[],int *it);

void main()
{
	int i,j,n,iter;
	double a[N][N],b[N],x[N],D,eps;

//  generowanie ukladu rownan	
	n=3;
	printf("podaj D ");
	scanf("%lf",&D);

	for(i=0;i<n;i=i+1)
	{ for(j=0;j<n;j=j+1) a[i][j]=1.0;  b[i]=3.0;}
	a[0][2]=.0;  b[0]=2.;

	for(i=0;i<n;i=i+1) 
	{ a[i][i]=a[i][i]+D;
	  b[i]=b[i]+D; }
	for(i=0;i<n;i=i+1)
	{  printf("%lf  %lf  %lf  %lf\n",a[i][0],a[i][1],a[i][2],b[i]);}

	
	printf("podaj dokladnosc rozwiazania eps ");
	scanf("%lf",&eps);

// rozwiazanie
	iterj(a,b,n,eps,x,&iter);
	
	printf(" rozwiazanie\n");
	for(i=0;i<n;i=i+1) printf("%lf\n",x[i]);
	printf("\nilosc iteracji = %d\n",iter);
	scanf("%d",&n);
}	
	



// funkcja rozwiazujaca zadany uklad rownan liniowych
// metoda iteracyjna Jacobiego
void iterj(double a[][N],double b[],int n,double eps,double x[],int *it)
{
	int i,j,iter,l=1;
	double aii, x0[N];

	for(i=0;i<n;i++)
	{
		aii=a[i][i];
		b[i]=b[i]/aii;
		for(j=0;j<n;j++) a[i][j]=-a[i][j]/aii;
		a[i][i]=0.;
	}

	for(i=0;i<n;i++) x0[i]=b[i];
	iter=0;

	while(l>0)
	{
		
	for(i=0;i<n;i++)
	{
		x[i]=b[i];
		for(j=0;j<n;j++) x[i]=x[i]+a[i][j]*x0[j];
	}
	iter=iter+1;
	if(iter>100)
	{
		printf("przekroczenie ilosci iteracji >100    ");
		return;
	}

	l=0;
	for(i=0;i<n;i++) if(fabs(x0[i]-x[i])>eps) l=l+1;
	for(i=0;i<n;i++) x0[i]=x[i];
	}

	*it=iter;

}
